#!/bin/bash
# Motorcomm Networks Interface Card driver install

drv_base=yt6801
drv_file=yt6801.ko
dir_cur=`pwd`
KDST=/lib/modules/`uname -r`/kernel/drivers/net/ethernet/motorcomm/
mod_inuse=`lsmod | grep -i yt6 | head -n 1 | cut -d ' ' -f 1`


drv_base1=`ls *.tar.gz -t | head -n 1`
if [ "$drv_base1" == "" ]; then
	echo no "*.tar.gz" file and try "*.tar"...
	drv_base1=`ls *.tar -t | head -n 1`
	if [ "$drv_base1" == "" ]; then
		echo no *.tar.gz or *.tar file found...exit.
		exit 1
	fi
	drv_base2=`basename ${drv_base1} .tar`
else
	drv_base2=`basename ${drv_base1} .tar.gz`
fi
drv_base=`echo $drv_base2 | tr A-Z a-z`
echo tar ball:$drv_base1, target dir:$drv_base

if [[ ! -d $drv_base ]];then
	mkdir -p $drv_base
	#tar -xf  YT6801_1.0.1.tar -C yt6801/
	tar -xf  $drv_base1 -C ${drv_base}/
else
	tar -xf  $drv_base1 -C ${drv_base}/
	#echo Please make sure driver files are ready.
	#echo Do nothing and quit.
fi


if [ $# -gt 0 ]; then
	if [[ "clean" == "$1" ]]; then
		#echo sudo rm ${KDST}$drv_file
		echo Uninstall Motorcomm NIC driver...
		sudo rm ${KDST}$drv_file > /dev/null 2>&1
		cd $drv_base
		make clean > /dev/null 2>&1
		cd $dir_cur
		echo Done.
		exit 0
	fi
	echo Do nothing and quit.
	exit 1
fi

if [[ -f $KDST$drv_file ]];then
	echo Driver has been installed before, press 'y' to continue and other to quit...
	read -rsN1 keyy
	#; echo $keyy
	if [[ "$keyy" != "y" ]]; then
		exit 0
	fi
fi

	cd $drv_base
	if [[ ! -f $drv_file ]];then
		echo No driver file,try make it	and pls wait...
		make > /dev/null 2>&1
		if [[ -f $drv_file ]];then
			echo Successful make and install now...; echo
			make install > /dev/null 2>&1
			echo Done.
		else
			echo Fail to make and pls check manually.
		fi
	else
		echo Driver file exists,install...;echo
		make install > /dev/null 2>&1

		echo Done.
	fi

	if [[ "$mod_inuse" == "" ]];then
		#echo yt6801 driver module is NOT in use...
		sudo insmod $drv_file
	else
		#echo yt6801 driver module is in use...
		sudo rmmod $mod_inuse
		sudo insmod $drv_file
	fi

	cd $dir_cur

